#!/usr/bin/env python
#coloRNA version 1.0
#Using Python 2.3.3 with Tkinter 8.4

# **********************************************************************
#
#=+rescale_coloRNA, written by Jamie LeBarron
#
#=* This program is free software; you can redistribute it and/or      *
#=* modify it under the terms of the GNU General Public License as     *
#=* published by the Free Software Foundation; either version 2 of the *
#=* License, or (at your option) any later version.                    *
#=*                                                                    *
#=* This program is distributed in the hope that it will be useful,    *
#=* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
#=* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
#=* General Public License for more details.                           *
#=*                                                                    *
#=* You should have received a copy of the GNU General Public License  *
#=* along with this program; if not, write to the                      *
#=* Free Software Foundation, Inc.,                                    *
#=* 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.      *
#=*                                                                    *
# **********************************************************************
#This file accepts a formated XY file (fn) and changes all XY values 
#according to the "factor" producing a re-scaled XY file (output)
#The value for factor should be in decimal (0.5) not percent form. 
import string

fn="fn.txt"
output="output.txt"
factor=float(0.50)

f=open(fn,"r")
o=open(output,"w")
cv=['Canvas', 'version']
bish=['bond', 'info', 'start', 'here']
bish2=['base', 'info', 'start', 'here']
startbond = False
startbase = False

for line in f.readlines():
   word = string.split(line)
   # set states, write out lines   
   if word == cv:
      o.write(line)     
      continue
   elif word == bish:
      o.write(line)
      startbond = True
      continue
   elif word == bish2:
      o.write(line)
      startbond = False
      startbase = True
      continue
      
   #if bonds are good
   if startbond == True:
       #if a line
       if len(word) == 5:
          newx1= ' '+str(round(float(word[1]) * factor,1)) 
          newy1= ' '+str(round(float(word[2]) * factor,1)) 
          newx2= ' '+str(round(float(word[3]) * factor,1)) 
          newy2= ' '+str(round(float(word[4]) * factor,1))
          newline = word[0]+newx1+newy1+newx2+newy2+'\n'
          o.write(newline)
       #if a circle
       elif len(word) == 4:
          newx=' '+str(round(float(word[1]) * factor,1))
          newy=' '+str(round(float(word[2]) * factor,1))
          newline=word[0]+newx+newy+' '+word[3]+'\n'
          o.write(newline)
       else:
          print 'something wrong'
          
   #copy multiplied bases
   if startbase == True:
      newx=' '+str(round(float(word[2]) * factor,1))
      newy=' '+str(round(float(word[3]) * factor,1))
      newline=word[0]+' '+word[1]+' '+newx+newy+'\n'
      o.write(newline)
      
f.close()
o.close()
